-- TFG BBDD Carnaval de Cádiz - Paloma Cortés


-- Creación de los índices



set default_tablespace = 'tb_idx';


--
-- Nombre: idx_persona_apellido1; Tipo: INDEX; Schema: general_accc; Tablespace: tb_idx
--
CREATE INDEX idx_persona_apellido1
    ON general_accc.persona USING btree
    (apellido1);

--
-- Nombre: idx_persona_alias; Tipo: INDEX; Schema: general_accc; Tablespace: tb_idx
--
CREATE INDEX idx_persona_alias
    ON general_accc.persona USING btree
    (alias);



--
-- Nombre: idx_agrupacionanio_entidad; Tipo: INDEX; Schema: general_accc; Tablespace: tb_idx
--
CREATE INDEX idx_agrupacionanio_entidad
    ON general_accc.agrupacion_anio USING btree
    (entidad);

--
-- Nombre: idx_agrupacionanio_anio; Tipo: INDEX; Schema: general_accc; Tablespace: tb_idx
--
CREATE INDEX idx_agrupacionanio_anio
    ON general_accc.agrupacion_anio USING btree
    (anio);

--
-- Nombre: idx_agrupacionanio_modalidad; Tipo: INDEX; Schema: general_accc; Tablespace: tb_idx
--
CREATE INDEX idx_agrupacionanio_modalidad
    ON general_accc.agrupacion_anio USING btree
    (modalidad);

--
-- Nombre: idx_agrupacionanio_categoria; Tipo: INDEX; Schema: general_accc; Tablespace: tb_idx
--
CREATE INDEX idx_agrupacionanio_categoria
    ON general_accc.agrupacion_anio USING btree
    (categoria);

--
-- Nombre: idx_agrupacionanio_interpreta_letra; Tipo: INDEX; Schema: general_accc; Tablespace: tb_idx
--
CREATE INDEX idx_agrupacionanio_interpretaliteraria
    ON general_accc.agrupacion_anio USING btree
    (interpreta_literaria);

--
-- Nombre: idx_agrupacionanio_interpreta_musica; Tipo: INDEX; Schema: general_accc; Tablespace: tb_idx
--
CREATE INDEX idx_agrupacionanio_interpretamusical
    ON general_accc.agrupacion_anio USING btree
    (interpreta_musical);

--
-- Nombre: idx_agrupacionanio_utilizatipo; Tipo: INDEX; Schema: general_accc; Tablespace: tb_idx
--
CREATE INDEX idx_agrupacionanio_utilizatipo
    ON general_accc.agrupacion_anio USING btree
    (utiliza_tipo);



--
-- Nombre: idx_evento_tipoevento; Tipo: INDEX; Schema: general_accc; Tablespace: tb_idx
--
CREATE INDEX idx_evento_anio
    ON general_accc.evento USING btree
    (anio);

--
-- Nombre: idx_evento_tipoevento; Tipo: INDEX; Schema: general_accc; Tablespace: tb_idx
--
CREATE INDEX idx_evento_tipoevento
    ON general_accc.evento USING btree
    (tipo_evento);



--
-- Nombre: idx_cargo_rol; Tipo: INDEX; Schema: general_accc; Tablespace: tb_idx
--
CREATE INDEX idx_cargo_rol
    ON general_accc.cargo USING btree
    (rol);

--
-- Nombre: idx_cargo_tipocargo; Tipo: INDEX; Schema: general_accc; Tablespace: tb_idx
--
CREATE INDEX idx_cargo_tipocargo
    ON general_accc.cargo USING btree
    (tipo_cargo);



--
-- Nombre: idx_cargo_rol; Tipo: INDEX; Schema: general_accc; Tablespace: tb_idx
--
CREATE INDEX idx_voz_tipovoz
    ON general_accc.voz USING btree
    (tipo_voz);



--
-- Nombre: idx_orquesta_instrumento; Tipo: INDEX; Schema: general_accc; Tablespace: tb_idx
--
CREATE INDEX idx_orquesta_instrumento
    ON general_accc.orquesta USING btree
    (instrumento);



--
-- Nombre: idx_documento_tipodocumento; Tipo: INDEX; Schema: general_accc; Tablespace: tb_idx
--
CREATE INDEX idx_documento_tipodocumento
    ON general_accc.documento USING btree
    (tipo_documento);
--
-- Nombre: idx_documento_tiposoporte; Tipo: INDEX; Schema: general_accc; Tablespace: tb_idx
--
CREATE INDEX idx_documento_tiposoporte
    ON general_accc.documento USING btree
    (tipo_soporte);



--
-- Nombre: idx_depositolegal_documento; Tipo: INDEX; Schema: general_accc; Tablespace: tb_idx
--
CREATE INDEX idx_depositolegal_documento
    ON general_accc.deposito_legal USING btree
    (documento);



--
-- Nombre: idx_letra_obra; Tipo: INDEX; Schema: general_accc; Tablespace: tb_idx
--
CREATE INDEX idx_letra_obra
    ON general_accc.letra USING btree
    (obra_literaria);

--
-- Nombre: idx_letra_autoria; Tipo: INDEX; Schema: general_accc; Tablespace: tb_idx
--
CREATE INDEX idx_letra_autoria
    ON general_accc.letra USING btree
    (autoria_letra);

--
-- Nombre: idx_letra_genero; Tipo: INDEX; Schema: general_accc; Tablespace: tb_idx
--
CREATE INDEX idx_letra_genero
    ON general_accc.letra USING btree
    (genero);



--
-- Nombre: idx_documentoletra_letra; Tipo: INDEX; Schema: general_accc; Tablespace: tb_idx
--
CREATE INDEX idx_documentoletra_letra
    ON general_accc.documento_letra USING btree
    (letra);



--
-- Nombre: idx_musica_obra; Tipo: INDEX; Schema: general_accc; Tablespace: tb_idx
--
CREATE INDEX idx_musica_obra
    ON general_accc.musica USING btree
    (obra_musical);

--
-- Nombre: idx_musica_autoria; Tipo: INDEX; Schema: general_accc; Tablespace: tb_idx
--
CREATE INDEX idx_musica_autoria
    ON general_accc.musica USING btree
    (autoria_musica);

--
-- Nombre: idx_musica_genero; Tipo: INDEX; Schema: general_accc; Tablespace: tb_idx
--
CREATE INDEX idx_musica_genero
    ON general_accc.musica USING btree
    (genero);



--
-- Nombre: idx_documentomusica_musica; Tipo: INDEX; Schema: general_accc; Tablespace: tb_idx
--
CREATE INDEX idx_documentomusica_musica
    ON general_accc.documento_musica USING btree
    (musica);



--
-- Nombre: idx_disenio_obra; Tipo: INDEX; Schema: general_accc; Tablespace: tb_idx
--
CREATE INDEX idx_disenio_obra
    ON general_accc.disenio USING btree
    (obra_grafica);

--
-- Nombre: idx_disenio_autoria; Tipo: INDEX; Schema: general_accc; Tablespace: tb_idx
--
CREATE INDEX idx_disenio_autoria
    ON general_accc.disenio USING btree
    (autoria_disenio);

--
-- Nombre: idx_disenio_tipodisenio; Tipo: INDEX; Schema: general_accc; Tablespace: tb_idx
--
CREATE INDEX idx_disenio_tipodisenio
    ON general_accc.disenio USING btree
    (tipo_disenio);



--
-- Nombre: idx_documentodisenio_disenio; Tipo: INDEX; Schema: general_accc; Tablespace: tb_idx
--
CREATE INDEX idx_documentodisenio_disenio
    ON general_accc.documento_disenio USING btree
    (disenio);


