-- TFG BBDD Carnaval de Cádiz - Paloma Cortés


-- Creación de procedimientos almacenados para altas, baja y modificación de
-- las obras de tipo Literaria




--
-- Nombre: alta_literaria; Tipo: FUNCTION; Schema: general_accc
--
CREATE OR REPLACE FUNCTION general_accc.alta_literaria (in_signatura_obra integer,
                                                        in_repertorio character varying,
                                                        in_id_doc integer,
                                                        in_3_1_1 character varying,
                                                        in_3_1_2 character varying,
                                                        in_3_1_3 character varying,
                                                        in_tipo_documento character varying,
                                                        in_tipo_soporte character varying,
                                                        in_ubicacion character varying,
                                                        in_deposito character varying,
                                                        in_estante character varying,
                                                        in_url character varying,
                                                        in_3_1_4 character varying,
                                                        in_3_1_5 text,
                                                        in_3_2_1 text,
                                                        in_3_2_2 text,
                                                        in_3_2_3 text,
                                                        in_3_2_4 text,
                                                        in_3_3_1 text,
                                                        in_3_3_2 text,
                                                        in_3_3_3 text,
                                                        in_3_3_4 text,
                                                        in_3_4_1 text,
                                                        in_3_4_2 text,
                                                        in_3_4_3 text,
                                                        in_3_4_4 text,
                                                        in_3_4_5 text,
                                                        in_3_5_1 text,
                                                        in_3_5_2 text,
                                                        in_3_5_3 text,
                                                        in_3_5_4 text,
                                                        in_3_6_1 text,
                                                        in_3_7_1 text,
                                                        in_3_7_2 text,
                                                        in_3_7_3 text,
                                                        in_descriptor integer,
                                                        in_esta_descrito boolean,
                                                        in_esta_digitalizado boolean,
                                                        in_en_deposito boolean,
                                                        in_observaciones_gestion text)
RETURNS character varying AS $$
DECLARE
    auxInteger integer;
    auxSignatura integer;
    auxDoc integer;
    auxCharacter character varying;
BEGIN

    IF in_signatura_obra IS NULL THEN
        SELECT nextval('general_accc.seq_obra'::regclass) INTO auxSignatura;
    ELSE
        auxSignatura := in_signatura_obra;
    END IF;

    IF in_id_doc IS NULL THEN
        SELECT nextval('general_accc.seq_documento'::regclass) INTO auxDoc;
    ELSE
        auxDoc := in_id_doc;
    END IF;

    BEGIN
        SELECT general_accc.__alta_obra (auxSignatura, 'Literaria', auxDoc,
                                         in_3_1_1, in_3_1_2, in_3_1_3, in_tipo_documento,
                                         in_tipo_soporte, in_ubicacion, in_deposito,
                                         in_estante, in_url, in_3_1_4, in_3_1_5, in_3_2_1,
                                         in_3_2_2, in_3_2_3, in_3_2_4, in_3_3_1, in_3_3_2,
                                         in_3_3_3, in_3_3_4, in_3_4_1, in_3_4_2, in_3_4_3,
                                         in_3_4_4, in_3_4_5, in_3_5_1, in_3_5_2, in_3_5_3,
                                         in_3_5_4, in_3_6_1, in_3_7_1, in_3_7_2, in_3_7_3,
                                         in_descriptor, in_esta_descrito,
                                         in_esta_digitalizado, in_en_deposito,
                                         in_observaciones_gestion)
            INTO auxCharacter;

    EXCEPTION WHEN others THEN
        RAISE EXCEPTION '%', SQLERRM;
    END;

    BEGIN
        INSERT INTO general_accc.literaria (obra, repertorio)
            VALUES (auxSignatura, in_repertorio);
        RETURN 'OK';

    EXCEPTION WHEN others THEN
        RAISE EXCEPTION 'No se ha creado el registro en obra literaria. %', SQLERRM;
    END;

EXCEPTION WHEN others THEN

    IF in_signatura_obra IS NULL THEN
        SELECT setval('general_accc.seq_obra'::regclass, currval('general_accc.seq_obra'::regclass) - 1, true)
            INTO auxInteger;
    END IF;

    IF in_id_doc IS NULL THEN
        SELECT setval('general_accc.seq_documento'::regclass, currval('general_accc.seq_documento'::regclass) - 1, true)
        INTO auxInteger;
    END IF;

    RAISE EXCEPTION '%', SQLERRM;
END;
$$ LANGUAGE plpgsql;




--
-- Nombre: modifica_literaria; Tipo: FUNCTION; Schema: general_accc
--
CREATE OR REPLACE FUNCTION general_accc.modifica_literaria (in_signatura_obra integer,
                                                            in_repertorio character varying,
                                                            in_id_doc integer,
                                                            in_3_1_1 character varying,
                                                            in_3_1_2 character varying,
                                                            in_3_1_3 character varying,
                                                            in_tipo_documento character varying,
                                                            in_tipo_soporte character varying,
                                                            in_ubicacion character varying,
                                                            in_deposito character varying,
                                                            in_estante character varying,
                                                            in_url character varying,
                                                            in_3_1_4 character varying,
                                                            in_3_1_5 text,
                                                            in_3_2_1 text,
                                                            in_3_2_2 text,
                                                            in_3_2_3 text,
                                                            in_3_2_4 text,
                                                            in_3_3_1 text,
                                                            in_3_3_2 text,
                                                            in_3_3_3 text,
                                                            in_3_3_4 text,
                                                            in_3_4_1 text,
                                                            in_3_4_2 text,
                                                            in_3_4_3 text,
                                                            in_3_4_4 text,
                                                            in_3_4_5 text,
                                                            in_3_5_1 text,
                                                            in_3_5_2 text,
                                                            in_3_5_3 text,
                                                            in_3_5_4 text,
                                                            in_3_6_1 text,
                                                            in_3_7_1 text,
                                                            in_3_7_2 text,
                                                            in_3_7_3 text,
                                                            in_esta_descrito boolean,
                                                            in_esta_digitalizado boolean,
                                                            in_en_deposito boolean,
                                                            in_observaciones_gestion text)
RETURNS character varying AS $$
DECLARE
    auxInteger integer;
    auxCharacter character varying;
    was general_accc.literaria%ROWTYPE;
BEGIN

    -- La condición se basa en la premisa de que siempre existe mínimo un documento por obra
    -- el cual será indicado, sea el primero u otro a modificar, por contener los datos de la obra;
    -- aunque los campos del mismo no vayan a actualizarse
    SELECT documento INTO auxInteger
        FROM general_accc.documento_obra
        WHERE documento = in_id_doc
            AND obra = in_signatura_obra;

    IF FOUND THEN

        -- Si la obra está asociada a una agrupación por interpretación hay que verificar
        -- el título de la misma, si este cambia, para el documento que responde al mismo
        IF in_3_1_2 IS NOT NULL THEN
        
            SELECT nombre INTO auxCharacter
                FROM general_accc.agrupacion_anio
                WHERE interpreta_literaria = in_signatura_obra;
                
            IF FOUND THEN
                SELECT doc.id INTO auxInteger
                    FROM general_accc.documento_obra AS d_o
                        INNER JOIN general_accc.documento AS doc
                            ON doc.id = d_o.documento
                        INNER JOIN general_accc.obra AS obra
                            ON obra.signatura = d_o.obra
                    WHERE d_o.obra = in_signatura_obra
                        AND doc.id <> in_id_doc
                        AND upper(doc."3_1_2_titulo") LIKE '%' || upper(auxCharacter) || '%';
                IF NOT FOUND AND position(upper(auxCharacter) in upper(in_3_1_2)) = 0 THEN
                    -- Si no hay otro con el nombre de la agrupación como título, es el actual
                    RAISE EXCEPTION 'El nombre de la obra no coincide con el de la agrupación que la interpreta.';
                END IF;
            END IF;
        END IF;

        SELECT * INTO was
            FROM general_accc.literaria
            WHERE obra = in_signatura_obra;

        IF FOUND THEN
            BEGIN
                UPDATE general_accc.literaria SET
                                              repertorio = COALESCE(in_repertorio, was.repertorio)
                    WHERE obra = in_signatura_obra;
            EXCEPTION WHEN others THEN
                RAISE EXCEPTION 'No se ha actualizado el registro en literaria. %', SQLERRM;
            END;

            BEGIN
                SELECT general_accc.__modifica_obra (in_signatura_obra,
                                                     in_id_doc, in_3_1_1, in_3_1_2,
                                                     in_3_1_3, in_tipo_documento,
                                                     in_tipo_soporte, in_ubicacion,
                                                     in_deposito, in_estante, in_url,
                                                     in_3_1_4, in_3_1_5, in_3_2_1,
                                                     in_3_2_2, in_3_2_3, in_3_2_4,
                                                     in_3_3_1, in_3_3_2, in_3_3_3,
                                                     in_3_3_4, in_3_4_1, in_3_4_2,
                                                     in_3_4_3, in_3_4_4, in_3_4_5,
                                                     in_3_5_1, in_3_5_2, in_3_5_3,
                                                     in_3_5_4, in_3_6_1, in_3_7_1,
                                                     in_3_7_2, in_3_7_3, in_esta_descrito,
                                                     in_esta_digitalizado, in_en_deposito,
                                                     in_observaciones_gestion)
                    INTO auxCharacter;

            EXCEPTION WHEN others THEN
                RAISE EXCEPTION '%', SQLERRM;
            END;
            RETURN 'OK';

        END IF;
    END IF;
    RAISE EXCEPTION 'El identificador de la obra no ha sido recibido, no refiere a una obra literaria o no existe.';

EXCEPTION WHEN others THEN
    RAISE EXCEPTION '%', SQLERRM;
END;
$$ LANGUAGE plpgsql;




--
-- Nombre: baja_literaria; Tipo: FUNCTION; Schema: general_accc
--
CREATE OR REPLACE FUNCTION general_accc.baja_literaria (in_signatura_obra integer,
                                                        in_documento integer)
RETURNS character varying AS $$
DECLARE
    auxInteger integer;
    auxCharacter character varying;
    was general_accc.documento_obra%ROWTYPE;
BEGIN

    BEGIN
        SELECT general_accc.__baja_obra (in_signatura_obra, in_documento)
            INTO auxCharacter;
    EXCEPTION WHEN others THEN
        RAISE EXCEPTION '%', SQLERRM;
    END;
    
    -- Llegado a este punto se ha eliminado el documento o el mismo está vinculado
    -- a otra obra o componente y se puede eliminar la obra literaria
    BEGIN
        DELETE FROM general_accc.literaria WHERE obra = in_signatura_obra;
        DELETE FROM general_accc.obra WHERE signatura = in_signatura_obra;
        RETURN 'OK';

    EXCEPTION WHEN others THEN
        RAISE EXCEPTION 'No se ha eliminado la obra literaria. (%) %', SQLSTATE, SQLERRM;
    END;

EXCEPTION WHEN others THEN
    RAISE EXCEPTION '%', SQLERRM;
END;
$$ LANGUAGE plpgsql;



--
-- Nombre: modifica_signatura_literaria; Tipo: FUNCTION; Schema: general_accc
--
CREATE OR REPLACE FUNCTION general_accc.modifica_signatura_literaria (in_signatura_nueva integer,
                                                                      in_signatura_vieja integer)
RETURNS character varying AS $$
DECLARE
    auxInteger integer;
    auxCharacter character varying;
BEGIN

    SELECT obra INTO auxInteger FROM general_accc.literaria WHERE obra = in_signatura_vieja;
    IF FOUND THEN

        BEGIN
            SELECT general_accc.__modifica_signatura_obra (in_signatura_nueva, in_signatura_vieja)
                INTO auxCharacter;
        EXCEPTION WHEN others THEN
            RAISE EXCEPTION '%', SQLERRM;
        END;
        RETURN 'OK';

    END IF;
    RAISE EXCEPTION 'La obra indicada no es literaria o no existe.';

EXCEPTION WHEN others THEN
    RAISE EXCEPTION '%', SQLERRM;
END;
$$ LANGUAGE plpgsql;



--
-- Nombre: doc_nuevo_a_literaria; Tipo: FUNCTION; Schema: general_accc
--
CREATE OR REPLACE FUNCTION general_accc.doc_nuevo_a_literaria (in_signatura_obra integer,
                                                               in_id_doc integer,
                                                               in_3_1_1 character varying,
                                                               in_3_1_2 character varying,
                                                               in_3_1_3 character varying,
                                                               in_tipo_documento character varying,
                                                               in_tipo_soporte character varying,
                                                               in_ubicacion character varying,
                                                               in_deposito character varying,
                                                               in_estante character varying,
                                                               in_url character varying,
                                                               in_3_1_4 character varying,
                                                               in_3_1_5 text,
                                                               in_3_2_1 text,
                                                               in_3_2_2 text,
                                                               in_3_2_3 text,
                                                               in_3_2_4 text,
                                                               in_3_3_1 text,
                                                               in_3_3_2 text,
                                                               in_3_3_3 text,
                                                               in_3_3_4 text,
                                                               in_3_4_1 text,
                                                               in_3_4_2 text,
                                                               in_3_4_3 text,
                                                               in_3_4_4 text,
                                                               in_3_4_5 text,
                                                               in_3_5_1 text,
                                                               in_3_5_2 text,
                                                               in_3_5_3 text,
                                                               in_3_5_4 text,
                                                               in_3_6_1 text,
                                                               in_3_7_1 text,
                                                               in_3_7_2 text,
                                                               in_3_7_3 text,
                                                               in_descriptor integer,
                                                               in_esta_descrito boolean,
                                                               in_esta_digitalizado boolean,
                                                               in_en_deposito boolean,
                                                               in_observaciones_gestion text)
RETURNS character varying AS $$
DECLARE
    auxInteger integer;
    auxDoc integer;
    auxCharacter character varying;
BEGIN

    SELECT obra INTO auxInteger FROM general_accc.literaria WHERE obra = in_signatura_obra;
    IF FOUND THEN

        IF in_id_doc IS NULL THEN
            SELECT nextval('general_accc.seq_documento'::regclass) INTO auxDoc;
        ELSE
            auxDoc := in_id_doc;
        END IF;

        BEGIN
            SELECT general_accc.__doc_nuevo_a_obra (in_signatura_obra, auxDoc, in_3_1_1,
                                                    in_3_1_2, in_3_1_3, in_tipo_documento,
                                                    in_tipo_soporte, in_ubicacion,
                                                    in_deposito, in_estante, in_url,
                                                    in_3_1_4, in_3_1_5, in_3_2_1,
                                                    in_3_2_2, in_3_2_3, in_3_2_4,
                                                    in_3_3_1, in_3_3_2, in_3_3_3,
                                                    in_3_3_4, in_3_4_1, in_3_4_2,
                                                    in_3_4_3, in_3_4_4, in_3_4_5,
                                                    in_3_5_1, in_3_5_2, in_3_5_3,
                                                    in_3_5_4, in_3_6_1, in_3_7_1,
                                                    in_3_7_2, in_3_7_3, in_descriptor,
                                                    in_esta_descrito, in_esta_digitalizado,
                                                    in_en_deposito, in_observaciones_gestion)
                INTO auxCharacter;

        EXCEPTION WHEN others THEN
            IF in_id_doc IS NULL THEN
                SELECT setval('general_accc.seq_documento'::regclass, currval('general_accc.seq_documento'::regclass) - 1, true)
                    INTO auxInteger;
            END IF;
            RAISE EXCEPTION '%', SQLERRM;
        END;

        RETURN 'OK';
    END IF;

    RAISE EXCEPTION 'El identificador de la obra literaria no ha sido recibido o no existe.';

EXCEPTION WHEN others THEN
    RAISE EXCEPTION '%', SQLERRM;
END;
$$ LANGUAGE plpgsql;



--
-- Nombre: doc_existente_a_literaria; Tipo: FUNCTION; Schema: general_accc
--
CREATE OR REPLACE FUNCTION general_accc.doc_existente_a_literaria (in_obra_literaria integer,
                                                                   in_documento integer)
RETURNS character varying AS $$
DECLARE
    auxInteger integer;
    auxCharacter character varying;
    was general_accc.documento%ROWTYPE;
BEGIN

    SELECT obra INTO auxInteger FROM general_accc.literaria WHERE obra = in_obra_literaria;
    IF FOUND THEN
        BEGIN
            SELECT general_accc.__alta_documento_obra (in_documento, in_obra_literaria)
                INTO auxCharacter;
        EXCEPTION WHEN others THEN
            RAISE EXCEPTION '%', SQLERRM;
        END;
        RETURN 'OK';

    END IF;
    RAISE EXCEPTION 'La obra indicada no es literaria.';

EXCEPTION WHEN others THEN
    RAISE EXCEPTION '%', SQLERRM;

END;
$$ LANGUAGE plpgsql;



--
-- Nombre: baja_documento_literaria; Tipo: FUNCTION; Schema: general_accc
--
CREATE OR REPLACE FUNCTION general_accc.baja_documento_literaria (in_documento integer,
                                                                  in_obra_literaria integer)
RETURNS character varying AS $$
DECLARE
    auxInteger integer;
    auxCharacter character varying;
    was general_accc.documento%ROWTYPE;
BEGIN

    SELECT obra INTO auxInteger FROM general_accc.literaria WHERE obra = in_obra_literaria;
    IF FOUND THEN
        BEGIN
            SELECT general_accc.__baja_documento_obra (in_documento, in_obra_literaria)
                INTO auxCharacter;
        EXCEPTION WHEN others THEN
            RAISE EXCEPTION '%', SQLERRM;
        END;
        RETURN 'OK';

    END IF;
    RAISE EXCEPTION 'La obra indicada no es literaria.';

EXCEPTION WHEN others THEN
    RAISE EXCEPTION '%', SQLERRM;

END;
$$ LANGUAGE plpgsql;
