-- TFG BBDD Carnaval de Cádiz - Paloma Cortés


-- Creación de procedimientos almacenados para altas, baja y modificación de
-- nivel de Obra




--
-- Nombre: __alta_obra; Tipo: FUNCTION; Schema: general_accc
--
CREATE OR REPLACE FUNCTION general_accc.__alta_obra (in_signatura_obra integer,
                                                     in_tipo_obra character varying,
                                                     in_id_doc integer,
                                                     in_3_1_1 character varying,
                                                     in_3_1_2 character varying,
                                                     in_3_1_3 character varying,
                                                     in_tipo_documento character varying,
                                                     in_tipo_soporte character varying,
                                                     in_ubicacion character varying,
                                                     in_deposito character varying,
                                                     in_estante character varying,
                                                     in_url character varying,
                                                     in_3_1_4 character varying,
                                                     in_3_1_5 text,
                                                     in_3_2_1 text,
                                                     in_3_2_2 text,
                                                     in_3_2_3 text,
                                                     in_3_2_4 text,
                                                     in_3_3_1 text,
                                                     in_3_3_2 text,
                                                     in_3_3_3 text,
                                                     in_3_3_4 text,
                                                     in_3_4_1 text,
                                                     in_3_4_2 text,
                                                     in_3_4_3 text,
                                                     in_3_4_4 text,
                                                     in_3_4_5 text,
                                                     in_3_5_1 text,
                                                     in_3_5_2 text,
                                                     in_3_5_3 text,
                                                     in_3_5_4 text,
                                                     in_3_6_1 text,
                                                     in_3_7_1 text,
                                                     in_3_7_2 text,
                                                     in_3_7_3 text,
                                                     in_descriptor integer,
                                                     in_esta_descrito boolean,
                                                     in_esta_digitalizado boolean,
                                                     in_en_deposito boolean,
                                                     in_observaciones_gestion text)
RETURNS character varying AS $$
DECLARE
    auxInteger integer;
    auxCharacter character varying;
BEGIN

    BEGIN
        INSERT INTO general_accc.obra (signatura, tipo_obra)
            VALUES (in_signatura_obra, in_tipo_obra::general_accc.enum_obra);
    EXCEPTION WHEN others THEN
        RAISE EXCEPTION 'No se ha creado el registro en obra. %', SQLERRM;
    END;


    BEGIN
        SELECT general_accc.__doc_nuevo_a_obra (in_signatura_obra, in_id_doc, in_3_1_1,
                                                in_3_1_2, in_3_1_3, in_tipo_documento,
                                                in_tipo_soporte, in_ubicacion,
                                                in_deposito, in_estante, in_url,
                                                in_3_1_4, in_3_1_5, in_3_2_1,
                                                in_3_2_2, in_3_2_3, in_3_2_4,
                                                in_3_3_1, in_3_3_2, in_3_3_3,
                                                in_3_3_4, in_3_4_1, in_3_4_2,
                                                in_3_4_3, in_3_4_4, in_3_4_5,
                                                in_3_5_1, in_3_5_2, in_3_5_3,
                                                in_3_5_4, in_3_6_1, in_3_7_1,
                                                in_3_7_2, in_3_7_3, in_descriptor,
                                                in_esta_descrito, in_esta_digitalizado,
                                                in_en_deposito, in_observaciones_gestion)
            INTO auxCharacter;
    EXCEPTION WHEN others THEN
        RAISE EXCEPTION '%', SQLERRM;
    END;

    RETURN 'OK';

EXCEPTION WHEN others THEN
    RAISE EXCEPTION '%', SQLERRM;
END;
$$ LANGUAGE plpgsql;




--
-- Nombre: __modifica_obra; Tipo: FUNCTION; Schema: general_accc
--
CREATE OR REPLACE FUNCTION general_accc.__modifica_obra (in_signatura_obra integer,
                                                         in_id_doc integer,
                                                         in_3_1_1 character varying,
                                                         in_3_1_2 character varying,
                                                         in_3_1_3 character varying,
                                                         in_tipo_documento character varying,
                                                         in_tipo_soporte character varying,
                                                         in_ubicacion character varying,
                                                         in_deposito character varying,
                                                         in_estante character varying,
                                                         in_url character varying,
                                                         in_3_1_4 character varying,
                                                         in_3_1_5 text,
                                                         in_3_2_1 text,
                                                         in_3_2_2 text,
                                                         in_3_2_3 text,
                                                         in_3_2_4 text,
                                                         in_3_3_1 text,
                                                         in_3_3_2 text,
                                                         in_3_3_3 text,
                                                         in_3_3_4 text,
                                                         in_3_4_1 text,
                                                         in_3_4_2 text,
                                                         in_3_4_3 text,
                                                         in_3_4_4 text,
                                                         in_3_4_5 text,
                                                         in_3_5_1 text,
                                                         in_3_5_2 text,
                                                         in_3_5_3 text,
                                                         in_3_5_4 text,
                                                         in_3_6_1 text,
                                                         in_3_7_1 text,
                                                         in_3_7_2 text,
                                                         in_3_7_3 text,
                                                         in_esta_descrito boolean,
                                                         in_esta_digitalizado boolean,
                                                         in_en_deposito boolean,
                                                         in_observaciones_gestion text)
RETURNS character varying AS $$
DECLARE
    auxCharacter character varying;
    auxInteger integer;
    was general_accc.documento%ROWTYPE;
BEGIN

    -- La condición se basa en la premisa de que siempre existe mínimo un
    -- documento por obra, el cual será indicado por contener los datos de
    -- la obra, sea el primero u otro a modificar; aunque los campos del
    -- mismo no vayan a actualizarse
    SELECT obra INTO auxInteger
        FROM general_accc.documento_obra
        WHERE documento = in_id_doc
            AND obra = in_signatura_obra;
    IF FOUND THEN

        -- Valida la composición de in_3_1_1 con las signaturas, requieren la
        -- signatura de la obra
        IF in_3_1_1 IS NOT NULL THEN
            BEGIN
                SELECT general_accc.__verifica_codigo_referencia(in_3_1_1, in_signatura_obra, null, in_id_doc)
                    INTO auxCharacter;
            EXCEPTION WHEN others THEN
                RAISE EXCEPTION '%', SQLERRM;
            END;
        END IF;

        SELECT * INTO was
            FROM general_accc.documento
            WHERE id = in_id_doc;
            
        SELECT tipo_obra INTO auxCharacter
            FROM general_accc.obra
            WHERE signatura = in_signatura_obra;
            
        SELECT COALESCE(in_tipo_documento, was.tipo_documento::character varying) INTO in_tipo_documento;
        SELECT COALESCE(in_3_1_4, was."3_1_4_nivel_descripcion"::character varying) INTO in_3_1_4;

        IF (in_tipo_documento = 'Texto' AND in_3_1_4 = 'Unidad documental compuesta')

                -- No tiene sentido una unidad compuesta de tipo imagen, sería un expediente
                OR (in_tipo_documento = 'Imagen' AND in_3_1_4 = 'Unidad documental compuesta'
                        AND (auxCharacter = 'Grafica' OR auxCharacter = 'Musical'))

                OR (in_tipo_documento = 'Audio' AND in_3_1_4 = 'Unidad documental compuesta'
                        AND (auxCharacter = 'Literaria' OR auxCharacter = 'Musical'))

                OR (in_tipo_documento = 'Video' AND in_3_1_4 = 'Unidad documental compuesta')

                OR (in_tipo_documento = 'Video' AND in_3_1_4 = 'Unidad documental simple'
                        AND auxCharacter = 'Grafica')

                OR (in_tipo_documento = 'Expediente' AND in_3_1_4 = 'Unidad documental compuesta')
        THEN

            -- Quizás mande todos a null, excepto el identificador de documento
            BEGIN
                SELECT general_accc.__modifica_documento (in_id_doc, in_3_1_1,
                                                          in_3_1_2, in_3_1_3,
                                                          in_tipo_documento,
                                                          in_tipo_soporte,
                                                          in_ubicacion, in_deposito,
                                                          in_estante, in_url,
                                                          in_3_1_4, in_3_1_5,
                                                          in_3_2_1, in_3_2_2, in_3_2_3,
                                                          in_3_2_4, in_3_3_1, in_3_3_2,
                                                          in_3_3_3, in_3_3_4, in_3_4_1,
                                                          in_3_4_2, in_3_4_3, in_3_4_4,
                                                          in_3_4_5, in_3_5_1, in_3_5_2,
                                                          in_3_5_3, in_3_5_4, in_3_6_1,
                                                          in_3_7_1, in_3_7_2, in_3_7_3,
                                                          in_esta_descrito,
                                                          in_esta_digitalizado,
                                                          in_en_deposito,
                                                          in_observaciones_gestion)
                    INTO auxCharacter;

            EXCEPTION WHEN others THEN
                RAISE EXCEPTION '%', SQLERRM;
            END;
            
        ELSE
            RAISE EXCEPTION 'La relación solicitada entre obra y documento no está permitida, según el tipo y el nivel de descripción.';
        END IF;
        
        RETURN 'OK';

    END IF;
    RAISE EXCEPTION 'El identificador de la obra no ha sido recibido, es erróneo o no existe.';

EXCEPTION WHEN others THEN
    RAISE EXCEPTION '%', SQLERRM;

END;
$$ LANGUAGE plpgsql;




--
-- Nombre: __baja_obra; Tipo: FUNCTION; Schema: general_accc
--
CREATE OR REPLACE FUNCTION general_accc.__baja_obra (in_signatura_obra integer,
                                                     in_documento integer)
RETURNS character varying AS $$
DECLARE
    auxInteger integer;
    auxCharacter character varying;
BEGIN

    -- La condición se basa en la premisa de que siempre existe mínimo un
    -- documento por obra el cual será indicado, sea el primero u otro a
    -- modificar, por contener los datos de la obra;
    -- aunque los campos del mismo no vayan a actualizarse
    SELECT documento INTO auxInteger
        FROM general_accc.documento_obra
        WHERE documento = in_documento
            AND obra = in_signatura_obra;
    IF FOUND THEN
        BEGIN
            DELETE FROM general_accc.documento_obra
                WHERE documento = in_documento
                    AND obra = in_signatura_obra;

        EXCEPTION WHEN others THEN
            RAISE EXCEPTION 'No se ha eliminado la relación entre documento y obra. (%) %', SQLSTATE, SQLERRM;
        END;

        BEGIN
            SELECT general_accc.__baja_documento (in_documento)
                INTO auxCharacter;
        EXCEPTION WHEN others THEN
            -- Estos dos mensajes se reciben cuando la relación del documento
            -- eliminada es la única que había para el mismo
            IF SQLERRM = 'La descripción de la obra refiere a un documento electrónico localizado.'
                    OR SQLERRM = 'La descripción de la obra refiere a un documento físico localizado.' THEN
                RAISE EXCEPTION 'No se puede eliminar la obra porque tiene documentos tangibles vinculados. %', SQLERRM;

            ELSEIF SQLERRM <> 'El documento aún refiere a algún elemento del inventario.' THEN
                RAISE EXCEPTION '%', SQLERRM;
            END IF;

            -- Llegado a este punto se ha eliminado el documento o el mismo está
            -- vinculado a otra obra o componente y se puede eliminar la obra,
            -- por la dependencia de herencia el resto se hace en la función
            -- específica del subtipo
        END;

        -- La eliminación en la tabla Obra la gestionan las funciones de los
        -- subtipos, porque antes deben retirarse los registros de los mismos

        RETURN 'OK';

    END IF;
    RAISE EXCEPTION 'La asociación entre documento y obra no existe';

EXCEPTION WHEN others THEN
    RAISE EXCEPTION '%', SQLERRM;
END;
$$ LANGUAGE plpgsql;




--
-- Nombre: __modifica_signatura_obra; Tipo: FUNCTION; Schema: general_accc
--
CREATE OR REPLACE FUNCTION general_accc.__modifica_signatura_obra (in_signatura_nueva integer,
                                                                   in_signatura_vieja integer)
RETURNS character varying AS $$
DECLARE
    auxInteger integer;
    auxCharacter character varying;
    auxRecord record;
BEGIN

    SELECT signatura INTO auxInteger
        FROM general_accc.obra
        WHERE signatura = in_signatura_nueva;

    IF NOT FOUND AND in_signatura_nueva < 100000 THEN
                                        -- Valor inicial de la secuencia de Obra
                                        
        -- Recorre los documentos asociados a la obra y cambiar en el código de
        -- referencia el identificador de la obra siempre que contuviese el anterior
        FOR auxRecord IN (SELECT id, "3_1_1_codigo_referencia"
                              FROM general_accc.documento
                              WHERE "3_1_1_codigo_referencia" LIKE '%' || in_signatura_vieja || '-%')
        LOOP
            IF position(in_signatura_vieja::character varying in auxRecord."3_1_1_codigo_referencia") = 10  THEN
                auxCharacter := auxRecord."3_1_1_codigo_referencia";
                auxCharacter := replace(auxCharacter, in_signatura_vieja::character varying || '-',
                                        in_signatura_nueva::character varying || '-');
                BEGIN

                    UPDATE general_accc.documento SET
                                                  "3_1_1_codigo_referencia" = auxCharacter
                        WHERE id = auxRecord.id;

                EXCEPTION WHEN others THEN
                    RAISE EXCEPTION 'No se ha actualizado el documento %. (%) %', auxRecord.id, SQLSTATE, SQLERRM;
                END;
            END IF;
        END LOOP;

        BEGIN
            UPDATE general_accc.obra SET
                                     signatura = in_signatura_nueva
                WHERE signatura = in_signatura_vieja;

        EXCEPTION WHEN others THEN
            RAISE EXCEPTION 'No se ha cambiado la signatura. (%) %', SQLSTATE, SQLERRM;
        END;
    	
        RETURN 'OK';
    END IF;
    RAISE EXCEPTION 'La signatura indicada ya está en uso o no puede utilizarse.';

EXCEPTION WHEN others THEN
    RAISE EXCEPTION '%', SQLERRM;
END;
$$ LANGUAGE plpgsql;



--
-- Nombre: __verifica_codigo_referencia; Tipo: FUNCTION; Schema: general_accc
--
CREATE OR REPLACE FUNCTION general_accc.__verifica_codigo_referencia (in_3_1_1 character varying,
                                                                      in_signatura_obra integer,
                                                                      in_signatura_componente integer,
                                                                      in_id_doc integer)
RETURNS character varying AS $$
DECLARE
    auxInteger integer;
    auxCharacter character varying;
BEGIN

    SELECT "3_1_1_codigo_referencia" INTO auxCharacter
        FROM general_accc.documento
        WHERE id = in_id_doc;
    IF in_3_1_1 IS NULL THEN
        in_3_1_1 := auxCharacter;
    END IF;

    IF position('ES.ACCC//' in in_3_1_1) <> 1  THEN
        RAISE EXCEPTION 'El valor de ISAD 3.1.1 Código de referencia debe empezar por ES.ACCC//';

    ELSEIF position(in_signatura_obra::character varying in in_3_1_1) < 10  THEN
        RAISE EXCEPTION 'El valor de ISAD 3.1.1 Código de referencia debe contener la signatura de la obra: %.', in_signatura_obra;

    ELSEIF in_signatura_componente IS NOT NULL AND position('-'||in_signatura_componente::character varying in in_3_1_1) < 11  THEN
        RAISE EXCEPTION 'El valor de ISAD 3.1.1 Código de referencia debe contener la signatura de la pieza de la obra: %.', in_signatura_componente;

    ELSEIF position(in_id_doc::character varying in in_3_1_1) < 11  THEN
        -- Este y el anterior establecen como mínimo 11 porque el anterior quizás
        -- no exista y la signatura ocupa como mínimo 1 caracter

        -- Admite que no se incluya el identificador del documento si no hay
        -- repeticiones en el campo 3_1_1_codigo_referencia
        SELECT id INTO auxInteger
            FROM general_accc.documento
            WHERE "3_1_1_codigo_referencia" = in_3_1_1
                AND id <> in_id_doc;
        IF FOUND THEN
            RAISE EXCEPTION 'El valor de ISAD 3.1.1 Código de referencia ya existe.';
        END IF;

    END IF;
    RETURN 'OK';

EXCEPTION WHEN others THEN
    RAISE EXCEPTION '%', SQLERRM;
END;
$$ LANGUAGE plpgsql;




--
-- Nombre: __componer_codigo_referencia; Tipo: FUNCTION; Schema: general_accc
--
CREATE OR REPLACE FUNCTION general_accc.__componer_codigo_referencia (in_signatura_obra integer,
                                                                      in_signatura_componente_obra integer,
                                                                      in_id_doc integer)
RETURNS character varying AS $$
BEGIN

    IF in_signatura_obra IS NULL OR in_id_doc IS NULL THEN
        RAISE EXCEPTION 'Es necesaria la signatura de la obra y el identificador del documento.';
    END IF;

    IF in_signatura_componente_obra IS NULL THEN
        RETURN 'ES.ACCC//' || in_signatura_obra || '-' || in_id_doc;
    ELSE
        RETURN 'ES.ACCC//' || in_signatura_obra || '-' || in_signatura_componente_obra || '-' || in_id_doc;
    END IF;

END;
$$ LANGUAGE plpgsql;




--
-- Nombre: __doc_nuevo_a_obra; Tipo: FUNCTION; Schema: general_accc
--
CREATE OR REPLACE FUNCTION general_accc.__doc_nuevo_a_obra  (in_signatura_obra integer,
                                                             in_id_doc integer,
                                                             in_3_1_1 character varying,
                                                             in_3_1_2 character varying,
                                                             in_3_1_3 character varying,
                                                             in_tipo_documento character varying,
                                                             in_tipo_soporte character varying,
                                                             in_ubicacion character varying,
                                                             in_deposito character varying,
                                                             in_estante character varying,
                                                             in_url character varying,
                                                             in_3_1_4 character varying,
                                                             in_3_1_5 text,
                                                             in_3_2_1 text,
                                                             in_3_2_2 text,
                                                             in_3_2_3 text,
                                                             in_3_2_4 text,
                                                             in_3_3_1 text,
                                                             in_3_3_2 text,
                                                             in_3_3_3 text,
                                                             in_3_3_4 text,
                                                             in_3_4_1 text,
                                                             in_3_4_2 text,
                                                             in_3_4_3 text,
                                                             in_3_4_4 text,
                                                             in_3_4_5 text,
                                                             in_3_5_1 text,
                                                             in_3_5_2 text,
                                                             in_3_5_3 text,
                                                             in_3_5_4 text,
                                                             in_3_6_1 text,
                                                             in_3_7_1 text,
                                                             in_3_7_2 text,
                                                             in_3_7_3 text,
                                                             in_descriptor integer,
                                                             in_esta_descrito boolean,
                                                             in_esta_digitalizado boolean,
                                                             in_en_deposito boolean,
                                                             in_observaciones_gestion text)
RETURNS character varying AS $$
DECLARE
    auxInteger integer;
    auxCharacter character varying;
BEGIN

    -- Desde todas las funciones que llaman aqui se hace una gestión previa de estos
    -- identificadores, teóricamente nunca deberían llegar vacíos
    IF in_signatura_obra IS NOT NULL AND in_id_doc IS NOT NULL THEN

        -- Valida la composición de in_3_1_1 con las signaturas
        IF in_3_1_1 IS NOT NULL THEN
            BEGIN
                SELECT general_accc.__verifica_codigo_referencia(in_3_1_1, in_signatura_obra, null, in_id_doc)
                    INTO auxCharacter;
            EXCEPTION WHEN others THEN
                RAISE EXCEPTION '%', SQLERRM;
            END;
        ELSE
            SELECT general_accc.__componer_codigo_referencia(in_signatura_obra, null, in_id_doc) INTO in_3_1_1;
        END IF;

        BEGIN
            SELECT general_accc.__alta_documento (in_id_doc, in_3_1_1, in_3_1_2,
                                                  in_3_1_3, in_tipo_documento,
                                                  in_tipo_soporte, in_ubicacion, in_deposito,
                                                  in_estante, in_url, in_3_1_4, in_3_1_5,
                                                  in_3_2_1, in_3_2_2, in_3_2_3, in_3_2_4,
                                                  in_3_3_1, in_3_3_2, in_3_3_3, in_3_3_4,
                                                  in_3_4_1, in_3_4_2, in_3_4_3, in_3_4_4,
                                                  in_3_4_5, in_3_5_1, in_3_5_2, in_3_5_3,
                                                  in_3_5_4, in_3_6_1, in_3_7_1, in_3_7_2,
                                                  in_3_7_3, in_descriptor, in_esta_descrito,
                                                  in_esta_digitalizado, in_en_deposito,
                                                  in_observaciones_gestion)
                INTO auxCharacter;
        EXCEPTION WHEN others THEN
            RAISE EXCEPTION '%', SQLERRM;
        END;

        BEGIN
            SELECT general_accc.__alta_documento_obra(in_id_doc, in_signatura_obra)
                INTO auxCharacter;
        EXCEPTION WHEN others THEN
            RAISE EXCEPTION '%', SQLERRM;
        END;

        RETURN 'OK';

    END IF;
    RAISE EXCEPTION 'La signatura de la obra y el identificador del documento son obligatorios.';

EXCEPTION WHEN others THEN
    RAISE EXCEPTION '%', SQLERRM;
END;
$$ LANGUAGE plpgsql;




--
-- Nombre: __alta_documento_obra; Tipo: FUNCTION; Schema: general_accc
--
CREATE OR REPLACE FUNCTION general_accc.__alta_documento_obra (in_documento integer,
                                                               in_obra integer)
RETURNS character varying AS $$
DECLARE
    aux1 character varying;
    aux2 character varying;
    aux3 character varying;
BEGIN

    SELECT documento INTO aux1
        FROM general_accc.documento_obra
        WHERE documento = in_documento
            AND obra = in_obra;

    IF NOT FOUND THEN

        SELECT tipo_documento, "3_1_4_nivel_descripcion" INTO aux1, aux2
            FROM general_accc.documento
            WHERE id = in_documento;

        SELECT tipo_obra INTO aux3
            FROM general_accc.obra
            WHERE signatura = in_obra;
            
        IF (aux1 = 'Texto' AND aux2 = 'Unidad documental compuesta')

                -- No tiene sentido una unidad compuesta de tipo imagen, sería un expediente
                OR (aux1 = 'Imagen' AND aux2 = 'Unidad documental compuesta'
                    AND (aux3 = 'Grafica' OR aux3 = 'Musical'))

                OR (aux1 = 'Audio' AND aux2 = 'Unidad documental compuesta'
                    AND (aux3 = 'Literaria' OR aux3 = 'Musical'))

                OR (aux1 = 'Video' AND aux2 = 'Unidad documental compuesta')

                OR (aux1 = 'Video' AND aux2 = 'Unidad documental simple' AND aux3 = 'Grafica')

                OR (aux1 = 'Expediente' AND aux2 = 'Unidad documental compuesta')
            THEN

            BEGIN
                INSERT INTO general_accc.documento_obra(documento, obra)
                    VALUES (in_documento, in_obra);
                RETURN 'OK';

            EXCEPTION WHEN others THEN
                RAISE EXCEPTION 'No se ha creado la relación entre documento y obra. (%) %', SQLSTATE, SQLERRM;
            END;

        END IF;
        RAISE EXCEPTION 'La relación solicitada entre obra y documento no está permitida, según el tipo y el nivel de descripción.';


    END IF;

    RAISE EXCEPTION 'La relación entre la obra y el documento ya existe.';


EXCEPTION WHEN others THEN
    RAISE EXCEPTION '%', SQLERRM;

END;
$$ LANGUAGE plpgsql;




--
-- Nombre: modifica_documento_obra; Tipo: FUNCTION; Schema: general_accc
--
-- No procede efectuar este intercambio, habrá que vincular el documento a la
-- obra que se pretenda (mediante las funciones llamadas doc_existente_a_*)
-- y luego desvincularlo de la primera (mediante la siguiente, baja_documento_obra()).
--





--
-- Nombre: __baja_documento_obra; Tipo: FUNCTION; Schema: general_accc
--
CREATE OR REPLACE FUNCTION general_accc.__baja_documento_obra (in_documento integer,
                                                               in_obra integer)
RETURNS character varying AS $$
DECLARE
    auxInteger integer;
    auxCharacter character varying;
BEGIN

    SELECT COUNT(documento) INTO auxInteger
        FROM general_accc.documento_obra
        WHERE obra = in_obra;

    IF auxInteger < 2 THEN
        RAISE EXCEPTION 'La relación entre documento y obra no existe, o es el mínimo asociado a la misma.';
    ELSE

        BEGIN
            DELETE FROM general_accc.documento_obra
                WHERE documento = in_documento
                    AND obra = in_obra;

        EXCEPTION WHEN others THEN
            RAISE EXCEPTION 'No se ha eliminado la relación. (%) %', SQLSTATE, SQLERRM;
        END;

        SELECT COUNT(documento) INTO auxInteger
            FROM general_accc.documento_obra
            WHERE documento = in_documento;
        BEGIN
            SELECT general_accc.__baja_documento (in_documento)
                INTO auxCharacter;

        EXCEPTION WHEN others THEN
            IF SQLERRM = 'El documento aún refiere a algún elemento del inventario.'THEN
                RETURN 'OK';
            ELSE
                -- El resto de errores que lanza la función anterior influyen en la eliminación
                -- de la relación entre la obra y el documento indicados, ya que implican que no 
                -- hay más relaciones entre el documento y el resto de contenidos en la base de datos
                RAISE EXCEPTION 'No se ha eliminado el documento. (%) %', SQLSTATE, SQLERRM;
            END IF;
        END;

        RETURN 'OK';
        
    END IF;

    RAISE EXCEPTION 'La relación entre documento y obra no existe.';

EXCEPTION WHEN others THEN
    RAISE EXCEPTION '%', SQLERRM;

END;
$$ LANGUAGE plpgsql;




--
-- Nombre: __doc_nuevo_a_componente; Tipo: FUNCTION; Schema: general_accc
--
CREATE OR REPLACE FUNCTION general_accc.__doc_nuevo_a_componente (in_signatura_obra integer,
                                                                  in_signatura_componente integer,
                                                                  in_id_doc integer,
                                                                  in_3_1_1 character varying,
                                                                  in_3_1_2 character varying,
                                                                  in_3_1_3 character varying,
                                                                  in_tipo_documento character varying,
                                                                  in_tipo_soporte character varying,
                                                                  in_ubicacion character varying,
                                                                  in_deposito character varying,
                                                                  in_estante character varying,
                                                                  in_url character varying,
                                                                  in_3_1_4 character varying,
                                                                  in_3_1_5 text,
                                                                  in_3_2_1 text,
                                                                  in_3_2_2 text,
                                                                  in_3_2_3 text,
                                                                  in_3_2_4 text,
                                                                  in_3_3_1 text,
                                                                  in_3_3_2 text,
                                                                  in_3_3_3 text,
                                                                  in_3_3_4 text,
                                                                  in_3_4_1 text,
                                                                  in_3_4_2 text,
                                                                  in_3_4_3 text,
                                                                  in_3_4_4 text,
                                                                  in_3_4_5 text,
                                                                  in_3_5_1 text,
                                                                  in_3_5_2 text,
                                                                  in_3_5_3 text,
                                                                  in_3_5_4 text,
                                                                  in_3_6_1 text,
                                                                  in_3_7_1 text,
                                                                  in_3_7_2 text,
                                                                  in_3_7_3 text,
                                                                  in_descriptor integer,
                                                                  in_esta_descrito boolean,
                                                                  in_esta_digitalizado boolean,
                                                                  in_en_deposito boolean,
                                                                  in_observaciones_gestion text)
RETURNS character varying AS $$
DECLARE
    auxInteger integer;
    auxCharacter character varying;
BEGIN

    IF in_signatura_obra IS NOT NULL AND in_signatura_componente IS NOT NULL THEN

        -- Valida la composición de in_3_1_1 con las signaturas,
        -- requieren la signatura de la obra y el componente
        IF in_3_1_1 IS NOT NULL THEN
            BEGIN
                SELECT general_accc.__verifica_codigo_referencia(in_3_1_1, in_signatura_obra, in_signatura_componente, in_id_doc)
                    INTO auxCharacter;
            EXCEPTION WHEN others THEN
                RAISE EXCEPTION '%', SQLERRM;
            END;
        ELSE
            SELECT general_accc.__componer_codigo_referencia(in_signatura_obra, in_signatura_componente, in_id_doc)
                INTO in_3_1_1;
        END IF;

        BEGIN
            SELECT general_accc.__alta_documento (in_id_doc, in_3_1_1, in_3_1_2,
                                                  in_3_1_3, in_tipo_documento,
                                                  in_tipo_soporte, in_ubicacion, in_deposito,
                                                  in_estante, in_url, in_3_1_4, in_3_1_5,
                                                  in_3_2_1, in_3_2_2, in_3_2_3, in_3_2_4,
                                                  in_3_3_1, in_3_3_2, in_3_3_3, in_3_3_4,
                                                  in_3_4_1, in_3_4_2, in_3_4_3, in_3_4_4,
                                                  in_3_4_5, in_3_5_1, in_3_5_2, in_3_5_3,
                                                  in_3_5_4, in_3_6_1, in_3_7_1, in_3_7_2,
                                                  in_3_7_3, in_descriptor, in_esta_descrito,
                                                  in_esta_digitalizado, in_en_deposito,
                                                  in_observaciones_gestion)
                INTO auxCharacter;
        EXCEPTION WHEN others THEN
            RAISE EXCEPTION '%', SQLERRM;
        END;
        RETURN 'OK';

    END IF;
    RAISE EXCEPTION 'La signatura y el identificador de la pieza son obligatorios.';

EXCEPTION WHEN others THEN
    RAISE EXCEPTION '%', SQLERRM;
END;
$$ LANGUAGE plpgsql;




-- __doc_existente_a_componente
-- Se desestima poruqe la funcionalidad resulta específica a cada componente,
-- ya que cada uno tiene su propia tabla para la relación N:M




--
-- Nombre: __baja_documento_componente; Tipo: FUNCTION; Schema: general_accc
--
CREATE OR REPLACE FUNCTION general_accc.__baja_documento_componente (in_documento integer,
                                                                     in_componente integer)
RETURNS character varying AS $$
DECLARE
    auxInteger integer;
    auxCharacter character varying;
    was general_accc.documento_obra%ROWTYPE;
BEGIN

    SELECT general_accc.__baja_documento (in_documento)
        INTO auxCharacter;
    RETURN 'OK';

EXCEPTION WHEN others THEN

    IF SQLERRM = 'El documento aún refiere a algún elemento del inventario.'THEN
        RETURN 'OK';
    ELSE
        -- El resto de errores que lanza la función anterior influyen en la eliminación
        -- de la relación entre el componente de obra y el documento indicados,
        -- ya que implican que no hay más relaciones entre el documento y el resto de
        -- contenidos en la base de datos
        RAISE EXCEPTION 'No se ha eliminado el documento. (%) %', SQLSTATE, SQLERRM;
    END IF;    
    RETURN 'OK';

END;
$$ LANGUAGE plpgsql;



