--------------------------------------------------------------------------------
--                 Pruebas a los SP en 03_SP_Entidad.sql                      --
--------------------------------------------------------------------------------



-- Pruebas en la tabla empresa

DO
    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
    
        RAISE NOTICE 'Prueba alta_empresa correcta';    
        SELECT id INTO auxInt1 FROM general_accc.actividad LIMIT 1;    
        SELECT general_accc.alta_empresa('Empresa 1', 'Localidad 1', 'Provincia 1', null, null, null, null, auxInt1) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba alta_empresa incorrecta, sin actividad';    
        SELECT general_accc.alta_empresa('Empresa 1', 'Localidad 1', 'Provincia 1', null, null, null, null, null) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba modifica_empresa correcta';
        SELECT entidad INTO auxInt1 FROM general_accc.empresa WHERE nombre = 'Empresa 1';  
        SELECT general_accc.modifica_empresa (auxInt1, null, null, null, '98754331', 'Domicilio 1', null, '956223298') INTO salida;
        RAISE NOTICE '%', salida;
        SELECT empresa INTO auxChar1 FROM general_accc.empresa WHERE entidad = auxInt1;
        RAISE NOTICE 'Valor actual del registro con id %: "%"', auxInt1, auxChar1;
 
    END;
    $$;





-- Pruebas sobre la tabla actividad_empresa

DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba alta_actividad_empresa correcta';
        SELECT entidad INTO auxInt1 FROM general_accc.empresa WHERE nombre = 'Empresa 1';  
        SELECT id INTO auxInt2
            FROM general_accc.actividad
            WHERE id NOT IN (SELECT actividad
                                 FROM general_accc.actividad_empresa
                                 WHERE empresa = auxInt1)
            LIMIT 1;
        SELECT general_accc.alta_actividad_empresa (auxInt2, auxInt1) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
        auxInt3 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba alta_actividad_empresa correcta';
        
        SELECT entidad INTO auxInt1 FROM general_accc.empresa WHERE nombre = 'Empresa 1';
        
        SELECT id INTO auxInt2
            FROM general_accc.actividad
            WHERE id NOT IN (SELECT actividad
                             FROM general_accc.actividad_empresa
                             WHERE empresa = auxInt1)
            ORDER BY id DESC
            LIMIT 1;

            
        SELECT general_accc.alta_actividad_empresa (auxInt2, auxInt1) INTO salida;
        RAISE NOTICE '%', salida;
        
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';
        RAISE NOTICE 'Prueba modifica_actividad_empresa correcta';
        SELECT id INTO auxInt2
            FROM general_accc.actividad_empresa
            WHERE empresa = auxInt1;
                             
        SELECT id INTO auxInt3
            FROM general_accc.actividad
            WHERE id NOT IN (SELECT actividad
                             FROM general_accc.actividad_empresa
                             WHERE empresa = auxInt1)
            ORDER BY id ASC
            LIMIT 1;
            
        SELECT general_accc.modifica_actividad_empresa (auxInt2, auxInt3, auxInt1) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba alta_actividad_empresa incorrecta, duplicado';
        
        SELECT entidad INTO auxInt1 FROM general_accc.empresa WHERE nombre = 'Empresa 1';
        
        SELECT actividad INTO auxInt2 FROM general_accc.actividad_empresa WHERE empresa = auxInt1 LIMIT 1;
            
        SELECT general_accc.alta_actividad_empresa (auxInt2, auxInt1) INTO salida;
        RAISE NOTICE '%', salida;

    END;
    $$;

DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxInt2 integer;
        auxInt3 integer;
        auxInt4 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba modifica_actividad_empresa incorrecta, cambiar la empresa';
                
        SELECT entidad INTO auxInt1 FROM general_accc.empresa WHERE nombre = 'Empresa 1';
        SELECT id, actividad, empresa INTO auxInt2, auxInt3, auxInt4
            FROM general_accc.actividad_empresa
            WHERE empresa = auxInt1 LIMIT 1;

        SELECT entidad INTO auxInt1
            FROM general_accc.empresa
            WHERE entidad <> auxInt4 LIMIT 1;
            
        SELECT general_accc.modifica_actividad_empresa (auxInt2, auxInt3, auxInt1) INTO salida;
        RAISE NOTICE '%', salida;

    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
        auxRecord record;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba baja_actividad_empresa completa, falla en el último';
           
        SELECT entidad INTO auxInt1 FROM general_accc.empresa WHERE nombre = 'Empresa 1';
        FOR auxRecord IN (SELECT id, actividad, empresa 
                              FROM general_accc.actividad_empresa
                              WHERE empresa = auxInt1)
        LOOP
            
            SELECT general_accc.baja_actividad_empresa (auxRecord.id, auxRecord.actividad, auxRecord.empresa) INTO salida;
            RAISE NOTICE '%', salida;
        END LOOP;

    END;
    $$;


DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba baja_empresa correcta';
        SELECT entidad INTO auxInt1 FROM general_accc.empresa WHERE nombre = 'Empresa 1';  
        SELECT general_accc.baja_empresa (auxInt1) INTO salida;
        RAISE NOTICE '%', salida;
        
    END;
    $$;





-- Pruebas en tabla persona

DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba alta_persona incorrecta, sin segundo apellido ni DNI';    
        SELECT general_accc.alta_persona ('Antonio', 'Martín', null, null, null, null, null, null, null, null, null, null, null, null, null, null) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba alta_persona incorrecta, sin segundo apellido y DNI erróneo';    
        SELECT general_accc.alta_persona ('Antonio', 'Martínez', null, null, '995', null, null, null, null, null, null, null, null, null, null, null) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba alta_persona incorrecta, sin segundo apellido y sin DNI ni localidad';    
        SELECT general_accc.alta_persona ('Antonio', 'Martínez', null, null, null, null, 'Calle 1', null, null, null, null, null, null, null, null, null) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba alta_persona correcta, sin segundo apellido y con domicilio';    
        SELECT general_accc.alta_persona ('Antonio', 'Martín', null, null, null, null, 'Calle', 'Localidad 1', null, null, null, null, null, null, null, null) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba alta_persona correcta, sin segundo apellido y con DNI';    
        SELECT general_accc.alta_persona ('Jose Antonio', 'Vera', null, null, '98754652', null, null, null, null, null, null, null, null, null, null, null) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba alta_persona correcta, con segundo apellido';    
        SELECT general_accc.alta_persona ('Antonio', 'Martínez', 'Ares', null, null, null, null, null, null, null, null, null, null, null, null, null) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;



DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba modifica_persona incorrecta, retira segundo apellido e indica DNI erróneo';  
        SELECT entidad INTO auxInt1 FROM general_accc.persona WHERE nombre = 'Antonio' AND apellido1 = 'Martínez' AND apellido2 = 'Ares';   
        SELECT general_accc.modifica_persona (auxInt1, null, null, '', null, '4567', null, null, null, null, null, null, null, null, null, null, null) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba alta_persona incorrecta, sin segundo apellido y domicilio erróneo'; 
        SELECT entidad INTO auxInt1 FROM general_accc.persona WHERE nombre = 'Antonio' AND apellido1 = 'Martínez' AND apellido2 = 'Ares';   
        SELECT general_accc.modifica_persona (auxInt1, null, null, '', null, null, null, 'Calle 1', null, null, null, null, null, null, null, null, null) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba modifica_persona correcta, retirando el segundo apellido'; 
        SELECT entidad INTO auxInt1 FROM general_accc.persona WHERE nombre = 'Antonio' AND apellido1 = 'Martínez' AND apellido2 = 'Ares';      
        SELECT general_accc.modifica_persona (auxInt1, null, null, '', 'El niño', null, null, 'Calle 1', 'Localidad 1', null, null, 'Profesión 1', null, null, null, null, 'Retirado en 2003 vuelve en 2016') INTO salida;
        RAISE NOTICE '%', salida;
        SELECT persona INTO auxChar1 FROM general_accc.persona WHERE entidad = auxInt1;
        RAISE NOTICE 'Valor actual del registro con id %: "%"', auxInt1, auxChar1;
    END;
    $$;


DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';
        
        RAISE NOTICE 'Prueba baja_persona correcta';
        SELECT entidad INTO auxInt1 FROM general_accc.persona WHERE nombre = 'Antonio' AND apellido1 = 'Martín';        
        SELECT general_accc.baja_persona (auxInt1) INTO salida;      
        RAISE NOTICE '%', salida;
        
        SELECT entidad INTO auxInt1 FROM general_accc.persona WHERE nombre = 'Jose Antonio' AND apellido1 = 'Vera';        
        SELECT general_accc.baja_persona (auxInt1) INTO salida;        
        RAISE NOTICE '%', salida;
        
        SELECT entidad INTO auxInt1 FROM general_accc.persona WHERE nombre = 'Antonio' AND apellido1 = 'Martínez';        
        SELECT general_accc.baja_persona (auxInt1) INTO salida;      
        RAISE NOTICE '%', salida;
        
    END;
    $$;



-- Pruebas en la tabla agrupacion

DO
    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE 'Prueba alta_agrupacion incorrecta, falta la localidad';
        SELECT general_accc.alta_agrupacion (null, null, 'Provincia 1', null, null, null) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba alta_agrupacion incorrecta, falta la provincia';
        SELECT general_accc.alta_agrupacion (null, 'Localidad 1', null, null, null, null) INTO salida;
        RAISE NOTICE '%', salida;
    END;
    $$;

DO
    $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';     
        RAISE NOTICE 'Prueba alta_agrupacion correcta, con identificador';
        SELECT general_accc.alta_agrupacion (99999, 'Localidad 1', 'Provincia 1', null, null, null) INTO salida;
        RAISE NOTICE '%', salida;
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';     
        RAISE NOTICE 'Prueba alta_agrupacion correcta, sin identificador';
        SELECT general_accc.alta_agrupacion (null, 'Localidad 1', 'Provincia 2', null, null, null) INTO salida;
        RAISE NOTICE '%', salida;
        SELECT agrupacion INTO salida FROM general_accc.agrupacion WHERE localidad = 'Localidad 1' AND entidad <> 99999;  
        RAISE NOTICE '    Nuevo registro';
        RAISE NOTICE '    %', salida;
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba modifica_agrupacion correcta, la del identificador aportado'; 
        SELECT general_accc.modifica_agrupacion (99999, null, null, 'Chirigota del Selu', 'Selu', 'Primer premio "Aguja de Oro" a una chirigota por Juan') INTO salida;
        RAISE NOTICE '%', salida;
        SELECT agrupacion INTO auxChar1 FROM general_accc.agrupacion WHERE entidad = 99999;
        RAISE NOTICE 'Valor actual del registro con id: "%"', 99999;
        RAISE NOTICE '    %',auxChar1;
    END;
    $$;
DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';  
        RAISE NOTICE 'Prueba modifica_agrupacion incorrecta, la del identificador aportado'; 
        SELECT general_accc.modifica_agrupacion (99999, '', null, '', null, null) INTO salida;
        RAISE NOTICE '%', salida;
 
    END;
    $$;

DO
 $$
    DECLARE
        salida character varying;
        auxChar1 character varying;
        auxInt1 integer;
    BEGIN 
        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';
        RAISE NOTICE 'Prueba baja_agrupacion correcta, la del identificador aportado'; 
        
        SELECT general_accc.baja_agrupacion (99999) INTO salida;        
        RAISE NOTICE '%', salida;
        
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';
        SELECT entidad INTO auxInt1 FROM general_accc.agrupacion WHERE localidad = 'Localidad 1';
        RAISE NOTICE 'Prueba baja_agrupacion correcta, la del identificador autogenerado: %', auxInt1;         
        SELECT general_accc.baja_agrupacion (auxInt1) INTO salida;        
        RAISE NOTICE '%', salida;

        RAISE NOTICE ' ';
        RAISE NOTICE ' '; 
        RAISE NOTICE ' ';        
        RAISE NOTICE 'Prueba baja_agrupacion incorrecta, de entidad que no es agrupación';        
        SELECT entidad INTO auxInt1 FROM general_accc.persona LIMIT 1;      
        SELECT general_accc.baja_agrupacion (auxInt1) INTO salida;      
        RAISE NOTICE '%', salida;
        
    END;
    $$;





-- Declaración de funciones utilizadas

-- general_accc.alta_empresa (in_nombre, in_localidad, in_provincia, in_cif, in_domicilio, in_telefono, in_contacto, in_actividad)

-- general_accc.modifica_empresa (in_entidad, in_nombre, in_localidad, in_provincia, in_cif, in_domicilio, in_telefono, in_contacto)

-- general_accc.baja_empresa (in_entidad)

-- general_accc.alta_actividad_empresa (in_actividad, in_empresa)

-- general_accc.modifica_actividad_empresa (in_id, in_actividad, in_empresa)

-- general_accc.baja_actividad_empresa (in_id, in_actividad, in_empresa)

-- general_accc.alta_persona (in_nombre, in_apellido1, in_apellido2, in_alias, in_dni, in_telefono, in_domicilio, in_localidad, in_provincia, in_cp, in_profesion, in_fec_nac, in_loc_nac, in_prov_nac, in_historia, in_observaciones)

-- general_accc.modifica_persona (in_entidad, in_nombre, in_apellido1, in_apellido2, in_alias, in_dni, in_telefono, in_domicilio, in_localidad, in_provincia, in_cp, in_profesion, in_fec_nac, in_loc_nac, in_prov_nac, in_historia, in_observaciones)

-- general_accc.baja_persona (in_entidad)

-- general_accc.alta_agrupacion (in_entidad, in_localidad, in_provincia, in_alias, in_contacto, in_observaciones)

-- general_accc.modifica_agrupacion (in_entidad, in_localidad, in_provincia, in_alias, in_contacto, in_observaciones)

-- general_accc.baja_agrupacion (in_entidad)

-- general_accc.modifica_id_agrupacion (in_id_nuevo, in_id_viejo)
